﻿using igHierarchicalGridRemotePaging.Models;
using Infragistics.Web.Mvc;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web.Mvc;

namespace igHierarchicalGridRemotePaging.Controllers
{
    public class HomeController : Controller
    {
        // GET: /Home/
        [GridDataSourceAction]
        [ActionName("BatchList")]
        public ActionResult BatchList()
        {

            var ds = new DataSet("List");
            DataTable batchTable = BatchListDataTable();
            DataTable childrenTable = ChildTable();

            ds.Tables.Add(batchTable);
            ds.Tables.Add(childrenTable);
           ds.Relations.Add("ListItem", batchTable.Columns["BatchNumber"], childrenTable.Columns["BatchNumber"]);

            return View("BatchList", ds);
        }

        #region Data
        private DataTable BatchListDataTable()
        {

            var dtData = new DataTable();
            dtData.Columns.Add("BatchNumber");
            dtData.Columns.Add("BatchGroupItemDate");
            dtData.Columns.Add("BatchComment");
            dtData.Columns.Add("NumberOfDocuments");
            dtData.Columns.Add("TotalTransfered");
            dtData.Columns.Add("NotTransfered");
            dtData.Columns.Add("CoId");

            DataRow row = null;

            for (int i = 0; i < 100; i++)
            {
                row = dtData.NewRow();
                dtData.Rows.Add(i
                    , DateTime.Now.AddDays(i)
                    , "BatchComment"
                    , i * 3
                    , i * 5 + i
                    , i * 2
                    , "testID");
            }

            dtData.PrimaryKey = new[] { dtData.Columns["BatchNumber"] };
            return dtData;
        }

        private DataTable ChildTable()
        {

            var dtData = new DataTable();
            dtData.Columns.Add("BatchNumber");
            dtData.Columns.Add("ChildId");
            dtData.Columns.Add("Prop2");
            dtData.Columns.Add("Prop3");
            dtData.Columns.Add("BoolProp");

            DataRow row = null;

            for (int i = 0; i < 50; i++)
            {
                for (int j = 0; j < 7; j++)
                {
                    row = dtData.NewRow();
                    dtData.Rows.Add(i
                        , i * 10 + j
                        , "Prop2"
                        , "Prop3"
                        , j % 2 == 0);
                }
            }

            dtData.PrimaryKey = new[] { dtData.Columns["ChildId"] };
            return dtData;
        }
        #endregion Data
    
    }
}
